.\" Copyright \(co 1985, 1986, 1987, 1988, 1989, 1990, 1991, 1994, 1996 X Consortium
.\"
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\"
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\"
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.\"
.\" Copyright \(co 1985, 1986, 1987, 1988, 1989, 1990, 1991 by
.\" Digital Equipment Corporation
.\"
.\" Portions Copyright \(co 1990, 1991 by
.\" Tektronix, Inc.
.\"
.\" Permission to use, copy, modify and distribute this documentation for
.\" any purpose and without fee is hereby granted, provided that the above
.\" copyright notice appears in all copies and that both that copyright notice
.\" and this permission notice appear in all copies, and that the names of
.\" Digital and Tektronix not be used in in advertising or publicity pertaining
.\" to this documentation without specific, written prior permission.
.\" Digital and Tektronix makes no representations about the suitability
.\" of this documentation for any purpose.
.\" It is provided ``as is'' without express or implied warranty.
.\" 
.\"
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft CW
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de IN		\" send an index entry to the stderr
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de hN
.ie t <\fB\\$1\fR>\\$2
.el <\fI\\$1\fP>\\$2
..
.ny0
.TH XSaveContext __libmansuffix__ __xorgversion__ "XLIB FUNCTIONS"
.SH NAME
XSaveContext, XFindContext, XDeleteContext, XUniqueContext \- associative look-up routines
.SH SYNTAX
.HP
int XSaveContext(\^Display *\fIdisplay\fP\^, XID \fIrid\fP\^, XContext
\fIcontext\fP\^, XPointer \fIdata\fP\^); 
.HP
int XFindContext(\^Display *\fIdisplay\fP\^, XID \fIrid\fP\^, XContext
\fIcontext\fP\^, XPointer *\fIdata_return\fP\^); 
.HP
int XDeleteContext(\^Display *\fIdisplay\fP\^, XID \fIrid\fP, XContext
\fIcontext\fP); 
.LP
XContext XUniqueContext(void); 
.SH ARGUMENTS
.IP \fIcontext\fP 1i
Specifies the context type to which the data belongs. 
.IP \fIdata\fP 1i
Specifies the data to be associated with the window and type.
.IP \fIdata_return\fP 1i
Returns the data.
.IP \fIdisplay\fP 1i
Specifies the connection to the X server.
.IP \fIrid\fP 1i
Specifies the resource ID with which the data is associated.
.SH DESCRIPTION
If an entry with the specified resource ID and type already exists,
.ZN XSaveContext
overrides it with the specified context.
The
.ZN XSaveContext
function returns a nonzero error code if an error has occurred
and zero otherwise.
Possible errors are
.ZN XCNOMEM
(out of memory).
.LP
Because it is a return value,
the data is a pointer.
The
.ZN XFindContext
function returns a nonzero error code if an error has occurred
and zero otherwise.
Possible errors are
.ZN XCNOENT
(context-not-found).
.LP
The
.ZN XDeleteContext
function deletes the entry for the given resource ID 
and type from the data structure.
This function returns the same error codes that
.ZN XFindContext
returns if called with the same arguments.
.ZN XDeleteContext
does not free the data whose address was saved.
.LP
The
.ZN XUniqueContext
function creates a unique context type that may be used in subsequent calls to
.ZN XSaveContext .
.SH "SEE ALSO"
\fI\*(xL\fP
