.\" Copyright \(co 1985, 1986, 1987, 1988, 1989, 1990, 1991, 1994, 1996 X Consortium
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\"
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\"
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.\"
.\" Copyright \(co 1985, 1986, 1987, 1988, 1989, 1990, 1991 by
.\" Digital Equipment Corporation
.\"
.\" Portions Copyright \(co 1990, 1991 by
.\" Tektronix, Inc.
.\"
.\" Permission to use, copy, modify and distribute this documentation for
.\" any purpose and without fee is hereby granted, provided that the above
.\" copyright notice appears in all copies and that both that copyright notice
.\" and this permission notice appear in all copies, and that the names of
.\" Digital and Tektronix not be used in in advertising or publicity pertaining
.\" to this documentation without specific, written prior permission.
.\" Digital and Tektronix makes no representations about the suitability
.\" of this documentation for any purpose.
.\" It is provided ``as is'' without express or implied warranty.
.\" 
.\"
.ds xT X Toolkit Intrinsics \- C Language Interface
.ds xW Athena X Widgets \- C Language X Toolkit Interface
.ds xL Xlib \- C Language X Interface
.ds xC Inter-Client Communication Conventions Manual
.na
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft CW
.\".ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.de IN		\" send an index entry to the stderr
..
.de Pn
.ie t \\$1\fB\^\\$2\^\fR\\$3
.el \\$1\fI\^\\$2\^\fP\\$3
..
.de ZN
.ie t \fB\^\\$1\^\fR\\$2
.el \fI\^\\$1\^\fP\\$2
..
.de hN
.ie t <\fB\\$1\fR>\\$2
.el <\fI\\$1\fP>\\$2
..
.ny0
.de EX
.sp
.nf
.ft CW
..
.de EE
.ft R
.fi
.sp
..
.TH XcmsColor __libmansuffix__ __xorgversion__ "XLIB FUNCTIONS"
.SH NAME
XcmsColor, XcmsRGB, XcmsRGBi, XcmsCIEXYZ, XcmsCIEuvY, XcmsCIExyY, XcmsCIELab, XcmsCIELuv, XcmsTekHVC, XcmsPad \- Xcms color structure
.SH STRUCTURES
The structure for
.ZN XcmsColor
contains:
.LP
.EX
typedef unsigned long XcmsColorFormat;			/\&* Color Specification Format */

typedef struct {
	union {
		XcmsRGB RGB;
		XcmsRGBi RGBi;
		XcmsCIEXYZ CIEXYZ;
		XcmsCIEuvY CIEuvY;
		XcmsCIExyY CIExyY;
		XcmsCIELab CIELab;
		XcmsCIELuv CIELuv;
		XcmsTekHVC TekHVC;
		XcmsPad Pad;
	} spec;
	unsigned long pixel;
	XcmsColorFormat format;
} XcmsColor;			/\&* Xcms Color Structure */
.EE
.LP
.EX
typedef double XcmsFloat;

typedef struct {
	unsigned short red;	/\&* 0x0000 to 0xffff */
	unsigned short green;	/\&* 0x0000 to 0xffff */
	unsigned short blue;	/\&* 0x0000 to 0xffff */
} XcmsRGB;		/\&* RGB Device */
.EE
.LP
.EX
typedef struct {
	XcmsFloat red;	/\&* 0.0 to 1.0 */
	XcmsFloat green;	/\&* 0.0 to 1.0 */
	XcmsFloat blue;	/\&* 0.0 to 1.0 */
} XcmsRGBi;		/\&* RGB Intensity */
.EE
.LP
.EX
typedef struct {
	XcmsFloat X;
	XcmsFloat Y;	/\&* 0.0 to 1.0 */
	XcmsFloat Z;
} XcmsCIEXYZ;		/\&* CIE XYZ */
.EE
.LP
.EX
typedef struct {
	XcmsFloat u_prime;	/\&* 0.0 to ~0.6 */
	XcmsFloat v_prime;	/\&* 0.0 to ~0.6 */
	XcmsFloat Y; 	/\&* 0.0 to 1.0 */
} XcmsCIEuvY;		/\&* CIE u'v'Y */
.EE
.LP
.EX
typedef struct {
	XcmsFloat x; 	/\&* 0.0 to ~.75 */
	XcmsFloat y; 	/\&* 0.0 to ~.85 */
	XcmsFloat Y; 	/\&* 0.0 to 1.0 */
} XcmsCIExyY;		/\&* CIE xyY */
.EE
.LP
.EX
typedef struct {
	XcmsFloat L_star; 	/\&* 0.0 to 100.0 */
	XcmsFloat a_star;
	XcmsFloat b_star;
} XcmsCIELab;		/\&* CIE L*a*b* */
.EE
.LP
.EX
typedef struct {
	XcmsFloat L_star; 	/\&* 0.0 to 100.0 */
	XcmsFloat u_star;
	XcmsFloat v_star;
} XcmsCIELuv;		/\&* CIE L*u*v* */
.EE
.LP
.EX
typedef struct {
	XcmsFloat H; 	/\&* 0.0 to 360.0 */
	XcmsFloat V; 	/\&* 0.0 to 100.0 */
	XcmsFloat C; 	/\&* 0.0 to 100.0 */
} XcmsTekHVC;		/\&* TekHVC */
.EE
.LP
.EX
typedef struct {
	XcmsFloat pad0;
	XcmsFloat pad1;
	XcmsFloat pad2;
	XcmsFloat pad3;
} XcmsPad;		/\&* four doubles */
.EE
.SH DESCRIPTION
The
.ZN XcmsColor
structure contains a union of substructures,
each supporting color specification encoding for a particular color space.
.SH "SEE ALSO"
XcmsAllocColor(__libmansuffix__),
XcmsStoreColor(__libmansuffix__),
XcmsConvertColors(__libmansuffix__),
.LP
\fI\*(xL\fP
